#include "bits/stdc++.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) (_x).begin(), (_x).end()
#define szof(_x) ((int) (_x).size())
#define TASK_NAME "parade"

using namespace std;
typedef long long ll;
typedef pair <int, int> pii;
const int bd = 17, bdv = 1 << bd;

int n, m;

int rmq[bdv * 2];

int segtree_set(int pos, int val) {
    pos += bdv;
    rmq[pos] = val;
    pos /= 2;
    while (pos) {
        rmq[pos] = min(rmq[pos * 2], rmq[pos * 2 + 1]);
        pos /= 2;
    }
    return 0;
}

int segtree_find(int v, int vl, int vr) {
    if (vl == vr) {
        if (rmq[v] == 0) {
            return vl;
        }
        return vl + 1;
    }
    if (rmq[v] > 0) {
        return vr + 1;
    }
    int vm = (vl + vr) / 2;
    int tmp = segtree_find(v * 2, vl, vm);
    if (tmp <= vm) {
        return tmp;
    }
    return segtree_find(v * 2 + 1, vm + 1, vr);
}

int main() {        
    freopen(TASK_NAME ".in", "r", stdin);
    freopen(TASK_NAME ".out", "w", stdout);
    
    vector<tuple<int, int , int>> v;
    vector<pii> inp;    
    vector<int> ans;


    scanf("%d%d", &n, &m);

    for (int i = 0; i < m; ++i) {
        int l, r;
        scanf("%d%d", &l, &r);
        --l; --r;
        v.puba(make_tuple(l, 0, i));
        v.puba(make_tuple(r, 1, i));
        inp.puba({l, r});
    }
    ans.resize(n);

    sort(bend(v));
    int c = 0;

    int prev = 0;
    multiset<int> now;
    for (int i = 0; i < n; ++i) {
        //cerr << i << endl;
        while (c < szof(v) && get<0>(v[c]) <= i && get<1>(v[c]) == 0) {
            now.insert(get<0>(v[c]));
            ++c;
        }
        int tmp = segtree_find(1, 0, bdv - 1);
        ans[i] = tmp;
        segtree_set(tmp, 1);

        while (c < szof(v) && get<0>(v[c]) <= i && get<1>(v[c]) == 1) {
            int lg = inp[get<2>(v[c])].ff;
            now.erase(now.find(lg));            
            ++c;
        }
        int to = i + 1;
        if (szof(now)) {
            to = *now.begin();
        }
        for (; prev < to; ++prev) {
            segtree_set(ans[prev], 0);
        }
    }

    cout << *max_element(bend(ans)) + 1 << "\n";

    for (int num: ans) {
        cout << num + 1 << " ";
    }
    cout << "\n";

    return 0;
}